let
  fromEnv = var: def:
    let val = builtins.getEnv var; in
    if val != "" then val else def;
in rec {
  perl = "/nix/store/kp4f6acmkhslpsy6zc9v2x7jzn9417b5-perl-5.20.1/bin/perl";
  shell = "/nix/store/8qk7fn8icdymgmcmm43vg74kz0wix31g-bash-4.3-p30/bin/bash";
  coreutils = "/nix/store/cdybb3hbbxf6k84c165075y7vkv24vm2-coreutils-8.23/bin";
  bzip2 = "/nix/store/7vpkyk61f73zc72jfs5hp9mw3kfjf246-bzip2-1.0.6/bin/bzip2";
  gzip = "/nix/store/1vld5gi97dc1g3iqhplazln7wccm8j1l-gzip-1.6/bin/gzip";
  xz = "/nix/store/ni1rbgsw9jv5iijj1igwp423j7vr30v7-xz-5.0.7/bin/xz";
  tar = "/nix/store/ir799s9dgjk6fykp5x4vqhs3gwldbs9c-gnutar-1.27.1/bin/tar";
  tarFlags = "--warning=no-timestamp";
  tr = "/nix/store/cdybb3hbbxf6k84c165075y7vkv24vm2-coreutils-8.23/bin/tr";
  curl = "/nix/store/79577nlvlvip5549bxg4kqpmvn3270dm-curl-7.42.1/bin/curl";
  nixBinDir = fromEnv "NIX_BIN_DIR" "/nix/store/kyizilshqhd28v1yap4ibnpvz5y62ism-nix-1.9/bin";
  nixPrefix = "/nix/store/kyizilshqhd28v1yap4ibnpvz5y62ism-nix-1.9";

  # If Nix is installed in the Nix store, then automatically add it as
  # a dependency to the core packages. This ensures that they work
  # properly in a chroot.
  chrootDeps =
    if dirOf nixPrefix == builtins.storeDir then
      [ (builtins.storePath nixPrefix) ]
    else
      [ ];
}
